/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Jetable mail extension
 *
 * The Initial Developer of the Original Code is Nicolas Moreau
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Original Author: Nicolas Moreau (nmoreau@stricto-sensu.net)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
function buitList(){

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefBranch);
		
	var mail,i,item,menupopup;
	menupopup=document.getElementById('jetablemail-tofill');
	
	for(i=1;i<6;i++){
		mail=prefs.getCharPref("jetable.email."+i);
		if(mail.length>0){
			item=document.createElement('menuitem');
			item.setAttribute('label',mail);
			menupopup.appendChild(item);
		}
			
	}
	document.getElementById('jetable-email').selectedItem=(menupopup.firstChild);
}

function JetableGetMail(mail,duree){

	document.getElementById('jetable-connection-error-1').style.display="none";
	document.getElementById('jetable-connection-error-2').style.display="none";
	document.getElementById('jetable-connection-error-3').style.display="none";
	document.getElementById('jetable-connection-error-4').style.display="none";
	document.getElementById('jetable-connection-error-5').style.display="none";
	document.getElementById('jetable-quirk-spacer').style.display="none";

	if(mail.length>0 && seemsMail(mail)){
	
		/* display */
		document.getElementById('jetable-go').disabled="true";
		document.getElementById('jetable-wait').style.display="block";
		document.getElementById('jetable-email').disabled="true";
		document.getElementById('jetable-duree').disabled="true";
		window.setTimeout("reset();",14000);
		
		saveMail(mail);
		
		var objHTTP;
		objHTTP = new XMLHttpRequest();
		objHTTP.open("POST",'http://jetable.org/plugins/getmail.php',false);
		objHTTP.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		objHTTP.send('time='+duree+'&email='+mail);
		var result=objHTTP.responseText;
		
		if(seemsMail(result)){
			window.arguments[0].value=result;
 			window.close();
		}
		else if(result==parseInt(result)){ //an error occured
			reset();
			document.getElementById('jetable-connection-error-'+result).style.display="block";
			
		}
	
	}
}


function reset(){
	document.getElementById('jetable-go').removeAttribute("disabled");
	document.getElementById('jetable-wait').style.display="none";
	document.getElementById('jetable-email').removeAttribute("disabled");
	document.getElementById('jetable-duree').removeAttribute("disabled");
}

function cleanUI(){
	// actions to do when closing popup
	reset();
	document.getElementById('jetable-connection-error-1').style.display="none";
	document.getElementById('jetable-connection-error-2').style.display="none";
	document.getElementById('jetable-connection-error-3').style.display="none";
	document.getElementById('jetable-connection-error-4').style.display="none";
	document.getElementById('jetable-connection-error-5').style.display="none";
	document.getElementById('jetable-quirk-spacer').style.visibility="hidden";
	document.getElementById('jetable-quirk-spacer').style.display="block";
}

function saveMail(mail){

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefBranch);
		
	var i;
	for(i=1;i<6;i++){
		if(prefs.getCharPref("jetable.email."+i).length < 1){
			prefs.setCharPref("jetable.email."+i,mail);
			break;
		}
	}
}

function seemsMail(mail){
	var filter=/^[^@]+@[^@]+\.[^@]+$/;
	return (filter.test(mail));
} 
